program Hex2Ti;
{$APPTYPE CONSOLE}
uses
  windows, sysutils;

var f,g:textfile;
    s,s2,adresse:string;
    i,adr,adr_old,adrcnt,cnt,bcnt:integer;
    hexeof:boolean;

function hex2int(zahl:string):longint;
var i,c: integer;
    erg,f: longint;

 function getzahl(z:char):longint;
 var s: string;
 begin
  case z of
  'A': getzahl:=10;
  'B': getzahl:=11;
  'C': getzahl:=12;
  'D': getzahl:=13;
  'E': getzahl:=14;
  'F': getzahl:=15;
  else begin s:=z; getzahl:=strtoint(s); end;
  end;
 end;

begin
  erg:=0;
  zahl:=trim(zahl);
  if length(zahl)=0 then begin result:=-1; exit; end;
  for i:=length(zahl) downto 1 do
  begin
   f:=1;
   if i<length(zahl) then for c:=1 to length(zahl)-i do f:=f*16;
   erg:=erg+getzahl(zahl[i])*f;
  end;
  result:=erg;
end;

begin
  writeln('Intel HEX Format zu TI-TXT Konverter  (Version 1.0)                            ');
  writeln('(C) 2003 SimSoft Inc.');
  writeln('');
  if FindCmdLineSwitch('h', ['/','-'], true) or (paramcount<2) then
  begin
  //  #132      #148      #129      #142      #153      #154
    writeln('HEX2TI <Quelldatei> <Ausgabedatei> [-h] [-p "MSP Programmer Parameter"]');
    writeln('<Quelldatei> und <Ausgabedatei> m'#129'ssen immer angegeben werden!');
    writeln('');
    writeln('Parameter:');
    writeln('  -h        Zeigt diesen Hilfebildschirm');
    writeln('  -p        Aktiviert den externen MSP430 Bootstrapprogrammer');
    writeln('            Danach m'#129'ssen die Parameter f'#129'r den BSL Programmer');
    writeln('            zwischen "" angeben werden!');
    writeln('');
    writeln('Parameter des BSL Programmers:');
    writeln('[-h] [-c{Port}] [-p{Datei}] [-w] [-1] [-m{Zahl}] [+ecpvrw]');
    writeln('');
    writeln('  -h        Zeigt die Hilfe des Programmers.');
    writeln('  -c{Port}  Legt den COM-Port fest (z.B. -cCOM2).');
    writeln('  -p{Datei} Gibt eine TI-TXT Datei mit der Interrupttabelle, die als');
    writeln('            Passwort ben'#148'tigt wird, an (z.B. -pPW.TXT).');
    writeln('  -w        Wartet auf <ENTER> vor Ende des Programms.');
    writeln('  -1        Programmieren und '#154'berpr'#129'fen wird in einem Schritt erledigt.');
    writeln('  -m{Zahl}  Anzahl der L'#148'schzyklen (z.B. -m20).');
    writeln('');
    writeln('>> Weiter (Enter dr'#129'cken!) <<');
    readln;
    writeln('');
    writeln('Programmablaufsteuerung [+ecpvrw]');
    writeln('  e         Komplettl'#148'schung');
    writeln('  c         '#154'berpr'#129'fen der L'#148'schung mittels Datei {Datei}');
    writeln('  p         Programmiere Datei {Datei}');
    writeln('  v         '#154'berpr'#129'fe Programmierung {Datei}');
    writeln('  r         Setzt angeschlossenen MSP430 zur'#129'ck. Startet Anwendung.');
    writeln('  w         Wartet auf <ENTER> vor Programmende.');
    writeln('Nur angegebene Optionen werden ausgef'#129'hrt!');
    writeln('');
    writeln('Bei keiner Angabe wird +ecpvr verwendet.');
    writeln('');
    exit;
  end;

  try
    assignfile(f,paramstr(1));
    reset(f);
    writeln('Quelldatei <'+paramstr(1)+'>');
  except
    writeln('Fehler beim Laden der angegebenen Datei "'+paramstr(1)+'"');
    exit;
  end;

  try
    assignfile(g,paramstr(2));
    rewrite(g);
    writeln('Ausgabedatei <'+paramstr(2)+'>');
  except
    writeln('Fehler beim Anlegen der Ausgabedatei "'+paramstr(2)+'"');
    exit;
  end;

  hexeof:=false;
  adr_old:=-1;
  s2:='';
  bcnt:=0;
  adrcnt:=0;

  while (not eof(f)) and (not hexeof) do
  begin
    readln(f,s);

    if length(s)>9 then
    begin

      if copy(s,8,2)='01' then
      begin
        hexeof:=true;
        if s2<>'' then
        begin
          delete(s2,length(s2),1);
          writeln(g,s2);
          s2:='';
        end;
        writeln(g,'q');
      end else

      begin
        adresse:=copy(s,4,4);
        adr:=hex2int(adresse);

        if adr_old<>adr then
        begin
          if s2<>'' then
          begin
            delete(s2,length(s2),1);
            writeln(g,s2);
            s2:='';
          end;
          writeln(g,'@'+adresse);
          inc(adrcnt);
        end;

        cnt:=hex2int(copy(s,2,2));
        for i:=0 to cnt-1 do
        begin
          s2:=s2+copy(s,i*2+10,2)+' ';
          inc(bcnt);
          if length(s2)>=47 then
          begin
            delete(s2,length(s2),1);
            writeln(g,s2);
            s2:='';
          end;
        end;

        adr_old:=adr+cnt;
      end;
    end;
  end;

  writeln('');
  writeln('Statistik:');
  writeln('  '+inttostr(bcnt)+' Bytes konvertiert');
  writeln('  '+inttostr(adrcnt)+' Adressbereiche gefunden');
  writeln('');
  closefile(f);
  closefile(g);
//  writeln(paramstr(paramcount));
  if FindCmdLineSwitch('p', ['/','-'], true) then
  begin
    writeln('MSP430 BSL Programmer starten...');
    s:=paramstr(paramcount)+' '+paramstr(2);
    writeln('BSLDEMO '+s);
    writeln('');
    i:=winexec(pchar('bsldemo '+s),SW_SHOWNORMAL);
    if i=ERROR_BAD_FORMAT then writeln('Nichtausfuehrbare Datei!');
    if i=ERROR_FILE_NOT_FOUND then writeln('BSLDEMO.EXE nicht gefunden!');
    if i=ERROR_PATH_NOT_FOUND then writeln('Verzeichnis nicht gefunden!');
    writeln('');
    writeln('>> Nach Ende des Programmierens Enter dr'#129'cken! <<');
    writeln('');
  end;
end.
